(*
Copyright 2009-2013 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Conditional_Rewriting_Impl
imports
  Conditional_Rewriting
  QDP_Framework_Impl
begin

type_synonym ('f, 'v) crules = "('f, 'v) crule list"

fun shows_conditions :: "('f :: show, 'v :: show) rule list \<Rightarrow> bool \<Rightarrow> shows"
where
  "shows_conditions [] _ = id" |
  "shows_conditions (x # xs) b = (shows (if b then '' | '' else '', '') +@+ 
    shows_rule' shows shows '' ->* '' x +@+ shows_conditions xs False)"

definition shows_crule :: "('f :: show, 'v :: show) crule \<Rightarrow> shows"
where
  "shows_crule cr = (shows_rule (fst cr) +@+ shows_conditions (snd cr) True)"

end

