(*
Copyright 2009-2013 René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Non_Inf_Order_Impl
imports
  Non_Inf_Order
  "$AFP/Show/Show"
  Check_Monad
begin

datatype_new ('f,'v) c_constraint =
  Conditional_C bool "('f, 'v) rule" "('f, 'v) rule" |
  Unconditional_C bool "('f, 'v) rule"

fun cc_satisfied :: "'f sig \<Rightarrow> ('f, 'v) trs \<Rightarrow> ('f, 'v) trs \<Rightarrow> ('f, 'v) c_constraint \<Rightarrow> bool" where
  "cc_satisfied F S NS (Unconditional_C stri (s, t)) =
    (\<forall> \<sigma>. \<Union>(funas_term ` range \<sigma>) \<subseteq> F \<longrightarrow> (s \<cdot> \<sigma>, t \<cdot> \<sigma>) \<in> (if stri then S else NS))"
| "cc_satisfied F S NS (Conditional_C stri (u, v) (s, t)) =
  (\<forall> \<sigma>. \<Union>(funas_term ` range \<sigma>) \<subseteq> F \<longrightarrow> (u \<cdot> \<sigma>, v \<cdot> \<sigma>) \<in> (if stri then S else NS) \<longrightarrow> (s \<cdot> \<sigma>, t \<cdot> \<sigma>) \<in> (if stri then S else NS))"

record ('f, 'v) non_inf_order =
  valid :: "shows check"
  ns :: "('f, 'v) rule \<Rightarrow> shows check"
  cc :: "('f, 'v) c_constraint \<Rightarrow> shows check"
  af :: "'f dep"
  desc :: "shows"

hide_const (open) valid ns af desc cc

locale generic_non_inf_order_impl = 
  fixes generate_non_inf_order :: "'a \<Rightarrow> ('f \<times> nat) list \<Rightarrow> ('f :: show,'v :: show)non_inf_order" 
  assumes generate_non_inf_order: "isOK(non_inf_order.valid (generate_non_inf_order rp F)) 
  \<Longrightarrow> isOK (check_allm (non_inf_order.ns (generate_non_inf_order rp F)) ns_list)
  \<Longrightarrow> isOK (check_allm (non_inf_order.cc (generate_non_inf_order rp F)) cc)
  \<Longrightarrow> \<exists> S NS. 
  non_inf_order S NS (set F) (non_inf_order.af (generate_non_inf_order rp F)) \<and> 
  set ns_list \<subseteq> NS \<and>
  Ball (set cc) (cc_satisfied (set F) S NS)"

end

